// Code generated by Community Administration CLI. DO NOT EDIT.

package model

import (
	"encoding/json"
	"fmt"
	"time"
)

type CommunityEvent interface {
	isCommunityEvent()
	GetBaseCommunityEvent() BaseCommunityEvent
}

type BaseCommunityEvent struct {
	CommunityEventType
	Date time.Time `json:"date"`
}

func NewCommunityEventFromByteSlice(byteSlice []byte) (*CommunityEvent, error) {
	var communityEvent CommunityEvent

	baseCommunityEvent := BaseCommunityEvent{}

	err := json.Unmarshal(byteSlice, &baseCommunityEvent)
	if err != nil {
		return nil, fmt.Errorf("json unmarshal to BaseCommunityEvent failed")
	}

	switch baseCommunityEvent.Type {
	case COMMUNITY_INFO_CHANGED:
		communityEventTypeModel := CommunityInfoChanged{}
		err = json.Unmarshal(byteSlice, &communityEventTypeModel)
		communityEvent = communityEventTypeModel
	case SUBSCRIPTION_FEE_SET:
		communityEventTypeModel := SubscriptionFeeSet{}
		err = json.Unmarshal(byteSlice, &communityEventTypeModel)
		communityEvent = communityEventTypeModel
	default:
		return nil, fmt.Errorf("unprocessed community event, %s", baseCommunityEvent.Type)
	}

	if err != nil {
		return nil, fmt.Errorf("json unmarshal to %s failed, %v", baseCommunityEvent.Type, err)
	}

	return &communityEvent, nil
}
